=== debian/changelog ===
trilinos (12.6.4-1) unstable; urgency=medium

  * New upstream release
  * Add myself to uploaders
  * Enable Kokkos build on 32-bit architectures (Closes: #835406)

 -- Graham Inggs <ginggs@debian.org>  Tue, 30 Aug 2016 11:46:35 +0200

trilinos (12.6.3-4) unstable; urgency=medium

  * Team upload
  * Only enable Kokkos assembly functions on amd64 (Closes: #815725)

 -- Graham Inggs <ginggs@debian.org>  Thu, 25 Aug 2016 12:33:23 +0200

trilinos (12.6.3-3) unstable; urgency=medium

  * Team upload
  * Use DEB_HOST_GNU_TYPE instead of DEB_HOST_MULTIARCH for BUILDDIR
  * Rebuild with GCC 6

 -- Graham Inggs <ginggs@debian.org>  Wed, 24 Aug 2016 14:01:43 +0200
